class Quandl::Cassandra::Models::Column < Quandl::Cassandra::Base

  table_name :columns

  require_relative 'column/read'
  require_relative 'column/write'
  
  class << self
    
    def read(*args)
      Quandl::Cassandra::Models::Column::Read.perform(*args)[:data]
    end
    
    def write(*args)
      Quandl::Cassandra::Models::Column::Write.perform(*args)
    end
    
    def find_max_time_by_ids(ids, collapses, order)
      unique = collapses.uniq.count == 1
      time = find_max_time_by_ids_and_collapse(ids, collapses.first, order) if unique
      time = find_max_time_by_ids_and_collapses(ids, collapses, order) unless unique
      Date.jd(time) if time.is_a?(Integer)
    end
    
    def find_max_time_by_ids_and_collapses(ids, collapses, order)
      # otherwise lookup each column seperately
      times = []
      ids.each_with_index do |id, index|
        column_collapse = collapses[index]
        next if column_collapse.blank?
        times << limit(1).order("type #{order}, time #{order}").where( id: id, type: column_collapse ).select(:time, :type).to_a[0].try(:[], 'time')
      end
      times.flatten.max
    end
    
    def find_max_time_by_ids_and_collapse(ids, collapse, order)
      limit(1).order("type #{order}, time #{order}").where( id: ids, type: collapse ).select(:time, :type).to_a[0].try(:[], 'time')
    end
    
  end
  
end