class Quandl::Cassandra::Models::Column::Read < Quandl::Strategy::Strategize

  require_relative 'read/collapse'
  require_relative 'read/column'
  require_relative 'read/data'
  require_relative 'read/offset'
  require_relative 'read/select_columns'
  require_relative 'read/row'
  require_relative 'read/transform'
  require_relative 'read/trim'
  require_relative 'read/type'
  require_relative 'read/limit'

  define_attributes :id, :trim_start, :trim_end, :collapse

  def self.perform(attributes)
    strategy = Quandl::Strategy.new( attributes ) do |c|
      c.use Quandl::Cassandra::Models::Column::Read::Type
      c.use Quandl::Cassandra::Models::Column::Read::Limit
      c.use Quandl::Cassandra::Models::Column::Read::Row
      c.use Quandl::Cassandra::Models::Column::Read::Column
      c.use Quandl::Cassandra::Models::Column::Read::Collapse
      c.use Quandl::Cassandra::Models::Column::Read::Transform
      c.use Quandl::Cassandra::Models::Column::Read::Offset
      c.use Quandl::Cassandra::Models::Column::Read::Trim
      c.use Quandl::Cassandra::Models::Column::Read::SelectColumns
      c.use Quandl::Cassandra::Models::Column::Read::Data
    end
    strategy.perform
  rescue => e
    Quandl::Logger.error("#{e} #{attributes}")
    raise
  end
  
  def count?
    attributes[:count] == true
  end
  
  def column_ids=(value)
    attributes[:column_ids] = Array(value).compact.flatten
  end
  
  def column_collapses
    attributes[:column_collapses]
  end
  
  def column_ids
    attributes[:column_ids]
  end
  
end
