class Quandl::Cassandra::Models::Column::Read::Collapse < Quandl::Cassandra::Models::Column::Read
  
  def perform
    attributes[:collapse] ||= :source
    attributes[:column_frequencies] ||= select_column_frequencies
    attributes[:column_collapses] = build_column_collapses_using_frequencies( attributes[:column_frequencies], attributes[:collapse] )
    attributes[:frequency] = find_largest_frequency( attributes[:column_frequencies] )
  end
  
  def select_column_frequencies
    freqs = Quandl::Cassandra::Models::ColumnAttribute.where( id: column_ids ).select(:id, :frequency).to_a unless column_ids.blank?
    freqs = [] if freqs.blank?
    column_ids.collect{|id| freqs.detect{|f| f['id'] == id }.try(:[], 'frequency').try(&:to_sym) }
  end
  
  def build_column_collapses_using_frequencies(freqs, collapse)
    freqs.collect do |frequency|
      # is frequency less than collapse?
      if Quandl::Operation::Collapse.collapses_greater_than( frequency ).include?( collapse )
        # this column needs to be collapsed
        collapse
      # otherwise frequency is greater than or equal to collapse
      else
        # so collapse is not needed
        :source
      end
    end
  end
  
  # [:daily, :weekly, :monthly]
  def find_largest_frequency(freqs)
    attributes[:column_frequencies].inject(:daily) do |freq,column_freq|
      # index of both frequencies
      freq_index = Quandl::Operation::Collapse.valid_collapses.index(freq)
      column_freq_index = Quandl::Operation::Collapse.valid_collapses.index(column_freq).to_i
      # is column_freq greater than freq?
      freq = column_freq if column_freq_index > freq_index
      freq
    end
  end
  
end