class Quandl::Cassandra::Models::Column::Read::Data < Quandl::Cassandra::Models::Column::Read
  
  def perform
    attributes[:data] = quandl_data( attributes[:data] ) unless count?
  end
  
  def quandl_data(data)
    # init
    data = Quandl::Cassandra::Models::Data.new( data )
    data.dataset_id = attributes[:id]
    data.column_ids = column_ids unless attributes[:column].present?
    data.column_frequencies = attributes[:column_frequencies] unless attributes[:column].present?
    # post process
    data = data.collapse( collapse ) if collapse?
    data = transform(data)
    data = trim(data)
    data = sort( data )
    data = row( data )
    data = limit(data)
    data
  end
  
  def trim(data)
    return data unless attributes[:data_table].present?
    data = data.sort_order( :asc ) if attributes[:data_table][:trim_start] || attributes[:data_table][:trim_end]
    data = data.trim_start( attributes[:data_table][:trim_start] ) if attributes[:data_table][:trim_start]
    data = data.trim_end( attributes[:data_table][:trim_end] ) if attributes[:data_table][:trim_end]
    data
  end
  
  def sort(data)
    data = data.sort_order( attributes[:order] )
  end
  
  def transform(data)
    data = data.transform( attributes[:transform] ) if attributes[:transform]
    data
  end
  
  def limit(data)
    data = data.limit( attributes[:pristine][:limit] ) if attributes[:pristine][:limit]
    data
  end
  
  def row(data)
    # if a row was requested and the data count is greater than a single row
    if attributes[:row].present? && data.count > 1
      # grab the last row
      data.data_array = [data.data_array[-1]]
    end
    data
  end
  
end