class Quandl::Cassandra::Models::Column::Read::Trim < Quandl::Cassandra::Models::Column::Read
  
  def perform
    trim_start_should_begin_at_start_of_frequency if trim_start? && collapse?
    trim_end_should_finish_at_end_of_frequency if trim_end? && collapse?
    trim_start_should_not_exceed_trim_end if trim_start? && trim_end?
  end
  
  def trim_start_should_begin_at_start_of_frequency
    self.trim_start = trim_start.start_of_frequency(collapse)
  end
  
  def trim_end_should_finish_at_end_of_frequency
    self.trim_end = trim_end.end_of_frequency(collapse)
  end
  
  def trim_start_should_not_exceed_trim_end
    # must not exceed trim_start
    self.trim_end = trim_start if trim_start > trim_end
  end
  
end