class Quandl::Cassandra::Models::Column::Write::GroupDataByColumn < Quandl::Cassandra::Models::Column::Write
  
  # INPUTS
  # { source: [ [1,2,3], [2,4,8], ... ], weekly: ... }
  
  def perform
    group_by_statement_values
  end
  
  def group_by_statement_values
    # for each [ [date, val, val], ... ]
    self.statement_values = []
    frequency_data.each do |frequency, rows|
      frequency = frequency.to_s
      rows.each do |row|
        # extract date
        date = row[0]
        # for each [ val, val, ... ]
        row[1..-1].each_with_index do |value, index|
          # ensure array
          cid = column_id(index)
          # add to values
          self.statement_values << [ cid, frequency, date, value] unless value.blank?
        end
      end
    end
  end
  
  def column_id(index)
    # ensure column_ids is defined
    self.column_ids ||= Quandl::Cassandra::Models::Dataset.find_column_ids_by_id(id)
    # ensure column_ids[index] is present
    self.column_ids[index] ||= Cql::Uuid.new(SecureRandom.uuid)
  end
  
end