class Quandl::Cassandra::Models::Column::Write::GroupDataByFrequency < Quandl::Cassandra::Models::Column::Write
  
  # INPUTS
  # [ [1,2,3], [2,4,8], ... ]
  
  # OUTPUTS
  # { source: [ [1,2,3], [2,4,8], ... ], weekly: ... }
  
  def perform
    self.frequency = data.frequency
    self.frequency_data = {}
    # clone source data
    self.data = data.clone
    self.frequency_data[:source] = data.data_array.clone
    # collapse and clone each frequency
    Quandl::Operation::Collapse.collapses_greater_than(data.frequency).each do |freq|
      self.frequency_data[freq] = self.data.clone.collapse(freq).data_array
    end
  end
  
end

